#include <conio.h>
#include <unistd.h>
#include <dmotor.h>
#include <dsensor.h>
#include <dbutton.h>
#include <rom/lcd.h>
#include <dsound.h>

int main(int argc, char **argv) {
  long offset;
  long err, err_diff, err_int = 0, err_old;
  long pid;
  int direction;
  
  int Kd = 210, Kp = 180, Ki = 10;
  long StartTime = get_system_up_time();
  long CrashTime = 0;

  ds_active(&SENSOR_1);

  cputs("pid");
  msleep(2000);

  dsound_system(DSOUND_BEEP);
  offset = (long)SENSOR_1;
  err_old = 0;
  
  lcd_int(offset);

  sleep(1);
  dsound_system(DSOUND_BEEP);


/*
  while (get_system_up_time() - StartTime < 20000) {
        offset = (long)SENSOR_1 - (long)SENSOR_3;
        lcd_int(offset);
        msleep(300);

  }

  cputs("end");

  return 0;
*/

  while( CrashTime == 0 ||
         (get_system_up_time() - CrashTime < 5000) )
  {
    err = (long)SENSOR_1 - offset;
    err_int = err_int + err + err_old;
    err_diff = (err - err_old);
    err_old = err;
    
    pid = (Kd * err_diff + Kp * err + Ki * err_int) /3000l;
    

    if (pid > 255)
       {
       pid = 255;
       CrashTime = get_system_up_time();
       }
    else if (pid < -255)
       {
       pid = -255;
       CrashTime = get_system_up_time();
       }
    else
       CrashTime = 0;

    if (pid < 0)
    {
      direction = rev;
      pid = -pid;
    }
    else
    {
      direction = fwd;
      pid = pid;
    }
    if (pid < 5)
      direction=brake;

    lcd_int(pid);
    // lcd_refresh();

    motor_a_dir(direction);
    motor_c_dir(direction);

    motor_a_speed(pid);
    motor_c_speed(pid);

    if(PRESSED(dbutton(), BUTTON_PROGRAM))
    {
      motor_a_dir(brake);
      motor_c_dir(brake);
      ds_passive(&SENSOR_1);
      cputs("stop");
      msleep(300);
      while (PRESSED(dbutton(), BUTTON_PROGRAM));
      motor_a_dir(off);
      motor_c_dir(off);
      cls();
      return(0);
    }
    msleep(20);
  }

cputs("end");
}
